<html>
<head>
<title>OGRE: OgreSubMesh.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreSubMesh.h</h1><a href="OgreSubMesh_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __SubMesh_H_</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __SubMesh_H_</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreVertexIndexData_8h.html">OgreVertexIndexData.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreMaterial_8h.html">OgreMaterial.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreRenderOperation_8h.html">OgreRenderOperation.h</a>"</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include "<a class="code" href="OgreVertexBoneAssignment_8h.html">OgreVertexBoneAssignment.h</a>"</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include "<a class="code" href="OgreProgressiveMesh_8h.html">OgreProgressiveMesh.h</a>"</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include "<a class="code" href="OgreAnimationTrack_8h.html">OgreAnimationTrack.h</a>"</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">namespace </span>Ogre {
<a name="l00042"></a>00042 
<a name="l00056"></a><a class="code" href="classOgre_1_1SubMesh.html">00056</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>
<a name="l00057"></a>00057     {
<a name="l00058"></a><a class="code" href="classOgre_1_1SubMesh.html#a41a130f156b145bffb3f4b5172c4c93">00058</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1Mesh.html">Mesh</a>;
<a name="l00059"></a><a class="code" href="classOgre_1_1SubMesh.html#48305c54a01e0c7a3376ea0a077c467f">00059</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1MeshSerializerImpl.html" title="Internal implementation of Mesh reading / writing for the latest version of the ...">MeshSerializerImpl</a>;
<a name="l00060"></a><a class="code" href="classOgre_1_1SubMesh.html#e60e96165c5d5495195fa0d49f031372">00060</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1MeshSerializerImpl__v1__2.html" title="Class for providing backwards-compatibility for loading version 1.2 of the .mesh...">MeshSerializerImpl_v1_2</a>;
<a name="l00061"></a><a class="code" href="classOgre_1_1SubMesh.html#ef9901d67ded13a151aa3d4fde3a7b17">00061</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1MeshSerializerImpl__v1__1.html" title="Class for providing backwards-compatibility for loading version 1.1 of the .mesh...">MeshSerializerImpl_v1_1</a>;
<a name="l00062"></a>00062     <span class="keyword">public</span>:
<a name="l00063"></a>00063         <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>();
<a name="l00064"></a>00064         ~<a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>();
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00068"></a><a class="code" href="classOgre_1_1SubMesh.html#931e3764e3bf1c3ef7431fc852770fb1">00068</a>         <span class="keywordtype">bool</span> useSharedVertices;
<a name="l00069"></a>00069 
<a name="l00071"></a><a class="code" href="classOgre_1_1SubMesh.html#10ed3ef8bb24a001bb89dc9e3cd88c31">00071</a>         <a class="code" href="classOgre_1_1RenderOperation.html#7a272218dae54048c87f31176c19e10d" title="The rendering operation type to perform.">RenderOperation::OperationType</a> operationType;
<a name="l00072"></a>00072 
<a name="l00080"></a><a class="code" href="classOgre_1_1SubMesh.html#1862a3ec9a3f2ed4ade8af69b41a809d">00080</a>         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> *vertexData;
<a name="l00081"></a>00081 
<a name="l00083"></a><a class="code" href="classOgre_1_1SubMesh.html#ad428fa6595c7fb01ef7543e5d8d6454">00083</a>         <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a> *indexData;
<a name="l00084"></a>00084 
<a name="l00104"></a><a class="code" href="classOgre_1_1SubMesh.html#77002e2ac2d5f5041e4b0fe3bd228245">00104</a>         <span class="keyword">typedef</span> std::vector&lt;unsigned short&gt; IndexMap;
<a name="l00105"></a><a class="code" href="classOgre_1_1SubMesh.html#e6b4c1d0724fe6a9a961b73bd646d3cf">00105</a>         IndexMap blendIndexToBoneIndexMap;
<a name="l00106"></a>00106 
<a name="l00107"></a><a class="code" href="classOgre_1_1SubMesh.html#8d4605861beedf02d1520489ca204bca">00107</a>         <a class="code" href="classOgre_1_1ProgressiveMesh.html#0c7f783f655c0691de3ac4a30ac13db2">ProgressiveMesh::LODFaceList</a> mLodFaceList;
<a name="l00108"></a>00108 
<a name="l00128"></a><a class="code" href="classOgre_1_1SubMesh.html#c63766998cb839ca582947d7545214f5">00128</a>         std::vector&lt;Vector3&gt; extremityPoints;
<a name="l00129"></a>00129 
<a name="l00131"></a><a class="code" href="classOgre_1_1SubMesh.html#c2b9fd25eb56625716d9e8915f4e0e7d">00131</a>         <a class="code" href="classOgre_1_1Mesh.html">Mesh</a>* parent;
<a name="l00132"></a>00132 
<a name="l00134"></a>00134         <span class="keywordtype">void</span> setMaterialName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; matName);
<a name="l00135"></a>00135         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMaterialName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00136"></a>00136 
<a name="l00139"></a>00139         <span class="keywordtype">bool</span> isMatInitialised(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00140"></a>00140 
<a name="l00147"></a>00147         <span class="keywordtype">void</span> _getRenderOperation(<a class="code" href="classOgre_1_1RenderOperation.html" title="&amp;#39;New&amp;#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; rend, <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> lodIndex = 0);
<a name="l00148"></a>00148 
<a name="l00161"></a>00161         <span class="keywordtype">void</span> addBoneAssignment(<span class="keyword">const</span> <a class="code" href="structOgre_1_1VertexBoneAssignment__s.html" title="Records the assignment of a single vertex to a single bone with the corresponding...">VertexBoneAssignment</a>&amp; vertBoneAssign);
<a name="l00162"></a>00162 
<a name="l00168"></a>00168         <span class="keywordtype">void</span> clearBoneAssignments(<span class="keywordtype">void</span>);
<a name="l00169"></a>00169 
<a name="l00171"></a><a class="code" href="classOgre_1_1SubMesh.html#b396ad138e9d8b48355d495215989881">00171</a>         <span class="keyword">typedef</span> std::multimap&lt;size_t, VertexBoneAssignment&gt; VertexBoneAssignmentList;
<a name="l00172"></a><a class="code" href="classOgre_1_1SubMesh.html#9c23baff85d3b4f60e37f2a514be1ada">00172</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">MapIterator&lt;VertexBoneAssignmentList&gt;</a> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">BoneAssignmentIterator</a>;
<a name="l00173"></a>00173 
<a name="l00178"></a>00178         <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">BoneAssignmentIterator</a> getBoneAssignmentIterator(<span class="keywordtype">void</span>);
<a name="l00179"></a>00179 
<a name="l00181"></a>00181         <span class="keywordtype">void</span> _compileBoneAssignments(<span class="keywordtype">void</span>);
<a name="l00182"></a>00182 
<a name="l00183"></a><a class="code" href="classOgre_1_1SubMesh.html#243e656daab531eea35d8b9fb5dc3b11">00183</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Wraps iteration over a const map.">ConstMapIterator&lt;AliasTextureNamePairList&gt;</a> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Wraps iteration over a const map.">AliasTextureIterator</a>;
<a name="l00187"></a>00187         <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Wraps iteration over a const map.">AliasTextureIterator</a> getAliasTextureIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00198"></a>00198         <span class="keywordtype">void</span> addTextureAlias(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; aliasName, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; textureName);
<a name="l00204"></a>00204         <span class="keywordtype">void</span> removeTextureAlias(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; aliasName);
<a name="l00207"></a>00207         <span class="keywordtype">void</span> removeAllTextureAliases(<span class="keywordtype">void</span>);
<a name="l00210"></a><a class="code" href="classOgre_1_1SubMesh.html#776598acc2a9c0d04d9019cd4137d905">00210</a>         <span class="keywordtype">bool</span> hasTextureAliases(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !mTextureAliases.empty(); }
<a name="l00213"></a><a class="code" href="classOgre_1_1SubMesh.html#b80c14813793491559cf24c60f455fd4">00213</a>         <span class="keywordtype">size_t</span> getTextureAliasCount(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTextureAliases.size(); }
<a name="l00214"></a>00214 
<a name="l00225"></a>00225         <span class="keywordtype">bool</span> updateMaterialUsingTextureAliases(<span class="keywordtype">void</span>);
<a name="l00226"></a>00226 
<a name="l00229"></a>00229         <a class="code" href="namespaceOgre.html#9046e6e0d12c46c57a9056987e9d158e" title="Type of vertex animation.">VertexAnimationType</a> getVertexAnimationType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00230"></a>00230 
<a name="l00235"></a>00235         <span class="keywordtype">void</span> generateExtremes(<span class="keywordtype">size_t</span> count);
<a name="l00236"></a>00236 
<a name="l00237"></a>00237     <span class="keyword">protected</span>:
<a name="l00238"></a>00238 
<a name="l00240"></a><a class="code" href="classOgre_1_1SubMesh.html#c9cc28e9a11b69a815fa9b3e52cd76f7">00240</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mMaterialName;
<a name="l00241"></a>00241 
<a name="l00243"></a><a class="code" href="classOgre_1_1SubMesh.html#25a7ea86e4beaadd868dacb760330e52">00243</a>         <span class="keywordtype">bool</span> mMatInitialised;
<a name="l00244"></a>00244 
<a name="l00246"></a><a class="code" href="classOgre_1_1SubMesh.html#b1f26bc16b9c1ea567ffcc4548e6466a">00246</a>         <a class="code" href="namespaceOgre.html#5dafc9e68bde8099ec5ad6c94e4cf19b" title="Alias / Texture name pair (first = alias, second = texture name).">AliasTextureNamePairList</a> mTextureAliases;
<a name="l00247"></a>00247 
<a name="l00248"></a><a class="code" href="classOgre_1_1SubMesh.html#1e190c3084110b7fa74a208f9c1f29f1">00248</a>         VertexBoneAssignmentList mBoneAssignments;
<a name="l00249"></a>00249 
<a name="l00251"></a><a class="code" href="classOgre_1_1SubMesh.html#97ac0719e0d2a1cd4f0ed4ec48a72912">00251</a>         <span class="keywordtype">bool</span> mBoneAssignmentsOutOfDate;
<a name="l00252"></a>00252 
<a name="l00254"></a><a class="code" href="classOgre_1_1SubMesh.html#7b6ef63e9dd8945accbc942307c8fcea">00254</a>         <span class="keyword">mutable</span> <a class="code" href="namespaceOgre.html#9046e6e0d12c46c57a9056987e9d158e" title="Type of vertex animation.">VertexAnimationType</a> mVertexAnimationType;
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 
<a name="l00258"></a>00258         <span class="keywordtype">void</span> removeLodLevels(<span class="keywordtype">void</span>);
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 
<a name="l00262"></a>00262     };
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 } <span class="comment">// namespace</span>
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 <span class="preprocessor">#endif</span>
<a name="l00267"></a>00267 <span class="preprocessor"></span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:56 2008
</p>
</body>
</html>
